#include <amxmodx>
#include <engine>
#include <cstrike>
#include <fakemeta>
#include <fakemeta_util>

new const classname[] = "gas_smokenade"

new sprite

public plugin_init(){
	register_plugin("TrainGrenades", "1.0", "UrShade")
	
	register_forward(FM_EmitSound, "FwdEmitSound")
	register_touch(classname, "worldspawn", "FwdTouch_FakeSmoke")
	register_think(classname, "FwdThink_FakeSmoke")

	set_task(5.0, "check_grenades", _, _, _, "b")
}

public plugin_precache(){
	sprite = precache_model("sprites/gas_puff_01.spr")
	precache_sound("weapons/grenade_hit1.wav")
}

public check_grenades()
{
	for(new id; id <= get_playersnum(); id++)
	{
		if(!is_user_connected(id) || !is_user_alive(id))
			continue

		if(!user_has_weapon(id,CSW_HEGRENADE))
			fm_give_item(id, "weapon_hegrenade")

		if(!user_has_weapon(id,CSW_SMOKEGRENADE))
			fm_give_item(id, "weapon_smokegrenade")

		if(!user_has_weapon(id,CSW_FLASHBANG)){
			if(cs_get_user_bpammo(id, CSW_FLASHBANG))
				fm_give_item(id, "weapon_flashbang")
			else
				fm_give_item(id, "weapon_flashbang")
		}
		fm_give_item(id, "weapon_flashbang")
	}
}
public FwdEmitSound(oEnt, chan, const szSample[], Float:vol, Float:att, flags, pitch){
	static const grenSound[] = "weapons/sg_explode.wav"
		
	if(equal(szSample, grenSound)){
		new Float:vOrigin[3], Float:vAngles[3], szModel[64], iOwner
		iOwner = entity_get_edict(oEnt, EV_ENT_owner)
		entity_get_vector(oEnt, EV_VEC_origin, vOrigin)
		entity_get_vector(oEnt, EV_VEC_angles, vAngles)
		entity_get_string(oEnt, EV_SZ_model, szModel, charsmax(szModel))
		entity_set_vector(oEnt, EV_VEC_origin, Float:{ 9999.9, 9999.9, 9999.9 })
		entity_set_int(oEnt, EV_INT_flags, FL_KILLME)
		new iEntity = create_entity("info_target")
		if(iEntity > 0){
			entity_set_string(iEntity, EV_SZ_classname, classname)
			entity_set_origin(iEntity, vOrigin)
			entity_set_vector(iEntity, EV_VEC_angles, vAngles)
			entity_set_int(iEntity, EV_INT_movetype, MOVETYPE_TOSS)
			entity_set_int(iEntity, EV_INT_solid, SOLID_BBOX)
			entity_set_float(iEntity, EV_FL_nextthink, get_gametime()+ 21.5)
			entity_set_float(iEntity, EV_FL_gravity, 0.5)
			entity_set_float(iEntity, EV_FL_friction, 0.8)
			entity_set_model(iEntity, szModel)
			new Float:vVelocity[3]
			vVelocity[0] = random_float(-220.0, 220.0)
			vVelocity[1] = random_float(-220.0, 220.0)
			vVelocity[2] = random_float( 200.0, 300.0)
			entity_set_vector(iEntity, EV_VEC_velocity, vVelocity)
			emit_sound(iEntity, chan, szSample, vol, att, flags, pitch)
			new iSmoke
			entity_set_int(iEntity, EV_INT_iuser4, iSmoke)
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_FIREFIELD)
			engfunc(EngFunc_WriteCoord, vOrigin[0])
			engfunc(EngFunc_WriteCoord, vOrigin[1])
			engfunc(EngFunc_WriteCoord, vOrigin[2] + 50)
			write_short(50)
			write_short(sprite)
			write_byte(100)
			write_byte(TEFIRE_FLAG_ALPHA)
			write_byte(50)
			message_end()
		}
	}
}


public FwdTouch_FakeSmoke(iEntity, iWorld){
	if(!is_valid_ent(iEntity))
		return PLUGIN_CONTINUE
	
	emit_sound(iEntity, CHAN_VOICE, "weapons/grenade_hit1.wav", 0.25, ATTN_NORM, 0, PITCH_NORM)
	
	new Float:vVelocity[3]
	entity_get_vector(iEntity, EV_VEC_velocity, vVelocity)
	
	if(vVelocity[1] <= 0.0 && vVelocity[2] <= 0.0){
		new Float:vOrigin[3]
		new iSmoke = entity_get_int(iEntity, EV_INT_iuser4)
		entity_get_vector(iEntity, EV_VEC_origin, vOrigin)
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_FIREFIELD)
		engfunc(EngFunc_WriteCoord, vOrigin[0])
		engfunc(EngFunc_WriteCoord, vOrigin[1])
		engfunc(EngFunc_WriteCoord, vOrigin[2] + 10)
		write_short(2)
		write_short(sprite)
		write_byte(2)
		write_byte(TEFIRE_FLAG_ALLFLOAT | TEFIRE_FLAG_ALPHA)
		write_byte(30)
		message_end()
	}
	
	return PLUGIN_CONTINUE
}

public FwdThink_FakeSmoke(iEntity){
	if(!is_valid_ent(iEntity))
		return PLUGIN_CONTINUE
	
	remove_entity(iEntity)
	
	return PLUGIN_CONTINUE
}